function Output=ERA(Y,fs,ncols,nrows,inputs,cutoff)


[outputs,l]=size(Y);       % size of the input matrix of data

% Find block sizes
row_blocks=fix(nrows/outputs)     % number of row blocks
nrows_adj=outputs*row_blocks;      % adjusted row numbers.
col_blocks=fix(ncols/inputs)      % number of column blocks (time steps)
ncols_adj=inputs*col_blocks;       % adjusted column numbers.
m=inputs;                     % inputs number.
q=outputs;                    % outputs number.


%Construct the Hankel matrix H(0).
H0=zeros(nrows_adj,ncols_adj);
for i=1:row_blocks
    for j=1:col_blocks
                    
          H0([(i-1)*q+1:i*q] ,[(j-1)*m+1:j*m] )=Y(:,((j-1)+i-1)*m+1:(j+i-1)*m); 
    end
end

% Construct the Hankel matrix H(1).
H1=zeros(nrows_adj,ncols_adj);
for i=1:row_blocks
    for j=1:col_blocks
                    
            H1([(i-1)*q+1:i*q] ,[(j-1)*m+1:j*m] )=Y(:,((j-1)+i)*m+1:(j+i)*m); 
    end
end



% Decompose the data matrix
[U,S,V]=svd(H0);
% Truncate the matrices using the cutoff to consider only the principal eigenvectors
D=S;
figure;plot(diag(D))
Dn=D(1:cutoff,1:cutoff);
Pn=U(:,1:cutoff);
Jn=V(:,1:cutoff);

% Calculate the realization of A and find eigenvalues and eigenvectors

Ah=Dn^(-0.5)*Pn'*H1*Jn*Dn^(-0.5);
[vv dd]=eig(Ah);
Ch=Pn(1:q,1:cutoff)*Dn^(0.5);
JnT=Jn';
Bh=Dn^(0.5)*JnT(1:cutoff,1:m);
 

% Extract the modal parameters 

[eVectors,eValues]=eig(Ah);  
s=log(eValues)*fs           % Eigenvalues (matrix) 
Modeshapes=Ch*eVectors;      % Eigenvectors (matrix)


% Output
Output.Evalues=diag(s); 
Output.Evectors=Modeshapes;


end