% Natural Excitation Technique function
% This function uses the time-domain method to find the correlation and it takes only the right hand side 

function RFs= NExT(data,refch,window,N,overlap,maxlags)

n_channels=size(data,1);
n_refs=length(refch);

  for ref_index=1:n_refs                   %Loop for reference channels
      for channel=1:n_channels            %Loop for all channels
          clear CCr2_sum CCr2_avg
         %-------------------------------------
        % reference channel and channel data
          x = data(refch(ref_index),:);       %reference channel data
          y = data(channel,:);                %selected channel data
        %--------------------------------------
        %Generation of cross-correlation vector
         for i=1:1:N
             clear CCr CCr2 
             wn=ceil((1-overlap)*window);         % window starting point
             x2=x([1+wn*(i-1):window+wn*(i-1)]);  % selected window on x
             y2=y([1+wn*(i-1):window+wn*(i-1)]);  % selected window on y
             CCr=xcorr(x2,y2,maxlags,'unbiased'); %Cross-correlation vector, 2*maxlags+1 elements
             CCr2=CCr(maxlags+1:2*maxlags+1);     %Cross-correlation vector, maxlags+1 elements
             CCr2_N(i,:)=CCr2;
         end

         CCr2_sum=zeros(1,length(CCr2_N(1,:)));

         for i=1:1:N 
             CCr2_sum=CCr2_sum+CCr2_N(i,:); 
         end
         CCr2_avg=CCr2_sum/N;
         %---------------------------------------
         % cross correlation matrix between reference channels and other channels
           Y(channel,[ref_index:n_refs:ref_index+n_refs*(maxlags)])=CCr2_avg; 
         %---------------------------------------
      end
  RFs=Y; %Approximated impulse response function matrix
end


