function dxdt = lotka_volterra(t,x,params,M)

global M;
params=parameters;
A=params.A;
R=params.R;
Ki=params.Ki;
eta=params.eta;



K=Ki.*(ones(4,1)+eta*M);
u = 0.005*ones(1,4);

% state variables
x1=x(1); x2=x(2); x3=x(3); x4=x(4);

% Set of equations
 dx1= R(1)*x1*(1-A(1,:)*[x1;x2;x3;x4]/K(1))+u(1)  ;
 dx2= R(2)*x2*(1-A(2,:)*[x1;x2;x3;x4]/K(2))+u(2)  ;
 dx3= R(3)*x3*(1-A(3,:)*[x1;x2;x3;x4]/K(3))+u(3)  ;
 dx4= R(4)*x4*(1-A(4,:)*[x1;x2;x3;x4]/K(4))+u(4)  ;

dxdt=[dx1 dx2 dx3 dx4]';
end